<?php
/**
 * @copyright (c) Kufer Software GmbH, Loisachstrasse 4, D-84453 Mühldorf
 */

/**
 * @copyright (c) Kufer Software GmbH, Loisachstrasse 4, D-84453 Mühldorf
 */
class Pruefziffer_D3 implements IPruefziffer
{
  public static function check($pKtoNr, $pBlz, $pGewichtung = array(), $pPruefZifferStelle = 9)
  {
    $ktoNr = \str_pad($pKtoNr, 10, '0', STR_PAD_LEFT);

    $result = self::variante1($ktoNr);
    if (!$result) {
      $result = self::variante2($ktoNr);
    }

    return $result;
  }

  private static function variante1($pKtoNr)
  {
    $gewichtung = array(0, 2, 1, 2, 1, 2, 1, 2, 1, 2);

    return Pruefziffer_00::check($pKtoNr, null, $gewichtung);
  }

  private static function variante2($pKtoNr)
  {
    $gewichtung = array(0, 2, 1, 2, 1, 2, 1, 2, 1, 2);

    return Pruefziffer_27::check($pKtoNr, null, $gewichtung);
  }
}